# main.py

import time
import machine
import binascii
import pycom
import sys

#from machine import Pin
from machine import Pin, I2C
SW1 = Pin('P16', mode=Pin.IN, pull=Pin.PULL_UP)
SW2 = Pin('P14', mode=Pin.IN, pull=Pin.PULL_UP)
SW3 = Pin('P13', mode=Pin.IN, pull=Pin.PULL_UP)
LED1 = Pin('P3', mode=Pin.OUT)
LED2 = Pin('P5', mode=Pin.OUT)
LED3 = Pin('P6', mode=Pin.OUT)

print('main    -> import sensors ')

from sensors import ds1820
#import onewire1

import sensors.ssd1306


print('main    -> import Config')
from config import Config
_config = Config()

"""### DS18B20 Sensorliste                                                 """
_ds_positions = {v: k for k, v in
                 _config.get_value('sensors', 'ds1820', 'positions').items()}

"""### allgemeine Variable                                                   """
loop_run = True                 # für loop in start_measurement

i2c = I2C(0, I2C.MASTER, pins=('P9', 'P10'))       # PyCom FiPy
oled = sensors.ssd1306.SSD1306_I2C(128, 64, i2c)           # x, y, bus



"""### Anfang def                                                            """
def start_measurement():
    global loop_run

    counter = 0

    """### DS18B20 Variable                                                 """
    # index         0     1     2     3     4     5     6       Variable für Temp.Sensor
    ds18b20takt = [ 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0]  # DS18B20 Temp. Aktuell
    ds18b20told = [35.0, 35.0, 35.0, 35.0, 35.0, 35.0, 35.0]  # DS18B20 Temp. alte Werte
    ds18b20korr = [ 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0]  # DS18B20 Temp. Korrektur
    ds18b20tol  =   2.0                                       # °C Toleranz für Ausreisser

    cnterrs = 0
    cnterrp = 0
    inderrp = 0
    tmperrp = 0
    cnterrn = 0
    inderrn = 0
    tmperrn = 0

    print('Messen --> Anfangswerte DS18B20 1...6 ',end=' ')
    if ds1820 is not None:
        for rom in ds1820.roms:
            ds1820.start_conversion(rom=rom)
        time.sleep_ms(750)

        ds18b20index = 0
        for rom in ds1820.roms:
            try:
                ds_measurement = ds1820.read_temp_async(rom=rom)
                ds_name = binascii.hexlify(rom).decode('utf-8')
                if ds_name in _ds_positions:
                    ds18b20index = ds18b20index + 1
                    ds18b20tmp = int(ds_measurement*10)/10               # 1 Dezimalstelle nach Komma
                    print('{:5.1f}'.format(ds18b20tmp),end=' ')
                    ds18b20told[ds18b20index]    = ds18b20tmp
            except:
                log("Did not find rom")
        print('')

    print('Messen --> Dauerschleife ')
    cntmax = 20                             # max. Durchläufe
    for counter in range (cntmax):          # Schleife x mal
    # while True:                           # Schleife unendlich
        counter = counter + 1
        print(counter, end='. ')

        data = {}
    #    print(data)
        if ds1820 is not None:
            for rom in ds1820.roms:
                ds1820.start_conversion(rom=rom)
        #    time.sleep_ms(750)
            time.sleep_ms(750)
            ds18b20index = 0
            # print('ds1820.roms: ', ds1820.roms)

            for rom in ds1820.roms:
                try:
                    #print('rom: {}'.format(rom))
                    ds_measurement = ds1820.read_temp_async(rom=rom)
                    ds_name = binascii.hexlify(rom).decode('utf-8')
                    # print( ds_name, end=' ')

                    if ds_name in _ds_positions:
                        ds18b20index = ds18b20index + 1
                        ds18b20tmp = int(ds_measurement*10)/10               # 1 Dezimalstelle nach Komma
                        ds18b20tmp = ds18b20tmp - ds18b20korr[ds18b20index]  # Korrektur
                        ds18b20old = ds18b20told[ds18b20index]
                        #print('DS18B20: {}. Temp.:   {} C   old: {} C'.format(ds18b20index, ds18b20tmp, ds18b20old))
                        ds18b20told[ds18b20index]    = ds18b20tmp
                        if (ds18b20tmp > ds18b20old + ds18b20tol):           # Aktueller Wert > alter Wert
                            print('korr>  {}. Temp.:  {} C ->  old: {} C'.format(ds18b20index, ds18b20tmp, ds18b20old))
                            cnterrs = cnterrs + 1
                            cnterrp = counter
                            inderrp = ds18b20index
                            tmperrp = ds18b20tmp

                            ds18b20tmp = ds18b20old
                            ds18b20told[ds18b20index]    = ds18b20tmp
                        if (ds18b20tmp < ds18b20old - ds18b20tol):           # Aktueller Wert < alter Wert
                            print('korr<  {}. Temp.:  {} C ->  old: {} C'.format(ds18b20index, ds18b20tmp, ds18b20old))
                            cnterrs = cnterrs + 1
                            cnterrn = counter
                            inderrn = ds18b20index
                            tmperrn = ds18b20tmp

                            ds18b20tmp = ds18b20old
                            ds18b20told[ds18b20index]    = ds18b20tmp
                        ds18b20takt[ds18b20index]    = ds18b20tmp
                        #data[_ds_positions[ds_name]] = ds18b20tmp
                except:
                    print("Did not find rom")


        if SW3() is 0:                          # DS18B20 Korrektur
            print('SW3 gedrückt')
            LED3.value(1)
            print('Messen --> Setzen der Korrekturwerte für  DS18B20 1...6   ')
            mittel = bme280tmp
            print('Messen --> BME280: ', mittel, end=' ')
            print('°C korr: ', end=' ')
            for index in range(7):
                ds18b20akt = ds18b20takt[index]
                #print('a', ds18b20akt, end=' ')
                ds18b20kor = (ds18b20akt - mittel)
                ds18b20kor = int(ds18b20kor*10)/10
                print(' ', ds18b20kor, end=' ')
                ds18b20korr[index] = ds18b20kor
            print(' ')
            print(' ', end=' ')
            LED3.value(0)


        """### Ausgabe der Messwerte                                         """
        pycom.rgbled(0x0000ff)
        # print(' ')
        print('Werte: ', end=' ')
        print('DS:', end=' ')
        for index in range(1,7):
            print(' {} C'.format(ds18b20takt[index]),end=' ')
        print(' ')

        oled.fill(0)                                         # alles aus
    #    oled.text("        hh:mm:ss",   0,  0)               # Textausgabe
        oled.text(str(counter),         0,  0)

        oled.text(str(cnterrs),         0,  9)

        oled.text(str(cnterrp),         0, 18)
        oled.text(str(inderrp),        50, 18)
        oled.text(str(tmperrp),        95, 18)
        oled.text(str(cnterrn),         0, 27)
        oled.text(str(inderrn),        50, 27)
        oled.text(str(tmperrn),        95, 27)

    #   oled.text("DS18B20   C     " ,  0, 36)
        oled.text(str(ds18b20takt[1]),  0, 45)
        oled.text(str(ds18b20takt[2]), 50, 45)
        oled.text(str(ds18b20takt[3]), 95, 45)
        oled.text(str(ds18b20takt[4]),  0, 54)
        oled.text(str(ds18b20takt[5]), 50, 54)
        oled.text(str(ds18b20takt[6]), 95, 54)
        oled.show()                                         # anzeigen

        pycom.rgbled(0x000000)                              # RGB-LED aus
        time.sleep(1)
### Ende von start_measurement()

"""### Start von Main                                                        """
print("main    -> Starting...")
start_measurement()
