# DS18B20-C3.py

# Didi Lamken   07.01.2020
# OneWire-Pin   P11 = BOB-HAT-Vx
# Library onewire_c und ds18x20_c
# OLED-Display

import  time
from    machine        import Pin, I2C
from sensors.ds18x20_c import DS18X20   # Temperatursensor DS18B20
from lib.onewire_c     import OneWire   # OneWire-Bus

import sensors.ssd1306                  # 1.3' OLED-Display

"""### allgemeine Variable                                                  """
ds18b20pin = 'P11'
"""### DS18B20 Variable                                                 """
# index         0     1     2     3     4     5     6       Variable für Temp.Sensor
ds18b20takt = [ 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0]  # DS18B20 Temp. Aktuell
ds18b20told = [35.0, 35.0, 35.0, 35.0, 35.0, 35.0, 35.0]  # DS18B20 Temp. alte Werte

errcnt = 0                           # Counter Error
errnr  = 0                          # Fehler Sensor Nr
rate   = 0                          # Fehler-rate

print('main    -> init DS18B20 ')
ow      = OneWire(Pin(ds18b20pin))
ds18b20 = DS18X20(ow)
roms    = ds18b20.scan()

print('Messen --> Anfangswerte DS18B20 1...6 ',end=' ')
ds18b20.convert_temp()
time.sleep_ms(750)
ds18b20nr = 0
for rom in roms:
    ds18b20nr += 1
    tmp = ds18b20.read_temp(rom)
    if tmp is not None:
        ds18b20tmp = int(tmp*10)/10
    else:
        ds18b20tmp = 0.0
        errcnt += 1
        errnr   = ds18b20nr
    print(ds18b20tmp, end='  ')
    ds18b20told[ds18b20nr] = ds18b20tmp
print(' ')

print('main    -> init OLED-Display ')
i2c  = I2C(0, I2C.MASTER, pins=('P9', 'P10'))       # I2C-Bus an PyCom FiPy
oled = sensors.ssd1306.SSD1306_I2C(128, 64, i2c)    # x, y, bus
print('           Textausgabe')
oled.fill(0)                                       # alles aus
oled.text("OLED-Display    ", 0,  0)               # Textausgabe
oled.show()

print('Messen --> Dauerschleife ')
cntmax = 100                             # max. Durchläufe
for counter in range (cntmax):          # Schleife x mal
# while True:                           # Schleife unendlich
    counter = counter + 1
    print( counter, end='. ' )
    ds18b20.convert_temp()
    time.sleep_ms(750)
    ds18b20nr = 0
    for rom in roms:
        ds18b20nr += 1
        # print(ds18b20nr)
        # print(rom)
        tmp = ds18b20.read_temp(rom)
        # print(tmp)
        if tmp is not None:
            ds18b20tmp = int(tmp*10)/10
        else:
            ds18b20tmp = 9999999
            errcnt += 1
            errnr   = ds18b20nr
        # print(ds18b20tmp)
###        print(ds18b20tmp, end='  ')
        ds18b20takt[ds18b20nr] = ds18b20tmp
###    print(' nr: ', errnr, ' err: ', errcnt, end=' ')
###    if errcnt > 0:
###        rate = int(counter / errcnt)
###        print( ' rate: ', rate, end=' ')
###    print(' ')

    """### Ausgabe der Messwerte                                         """
    print('Werte: ', end=' ')
    print('DS:', end=' ')
    ds18b20nr = 0
    for rom in roms:
        ds18b20nr += 1
        print(ds18b20takt[ds18b20nr], end=' ')

#    for ds18b20nr in range(1,7):
#        print(ds18b20takt[ds18b20nr], end=' ')
    #print(' nr: ', errnr, ' err: ', errcnt, end=' ')
    print(' err: ', errcnt, end=' ')
    cnterrn = 6
    if errcnt > 0:
        rate = int(counter / errcnt * cnterrn)
        print( ' rate: ', rate, end=' ')
    print(' ')

    oled.fill(0)                                         # alles aus
#    oled.text("        hh:mm:ss",   0,  0)               # Textausgabe
    oled.text("cnt:",               0,  0)
    oled.text(str(counter),        30,  0)
    oled.text("err:",               0,  9)
    oled.text(str(errcnt),         30,  9)
    oled.text("->",                60,  9)
    if errcnt > 0:
        oled.text(str(rate),       80,  9)

#    oled.text(str(counter),         0,  0)
#    oled.text("errnr",              0,  9)
#    oled.text(str(errnr),          64,  9)
#    oled.text("errcnt",             0, 18)
#    oled.text(str(errcnt),         64, 18)
#    oled.text("rate",               0, 27)
#    oled.text(str(rate),           64, 27)

#    oled.text("Waage         kg" ,  0,  9)
#    oled.text(str(hx711akt),       64,  9)
#    #oled.text("kg",               100,  9)
#    #oled.text("BME280         " ,  0, 18)
#    oled.text(" C   mBar    % "  ,  0, 18)
#    oled.text(str(bme280tmp)     ,  0, 27)
#    oled.text(str(bme280pre)     , 40, 27)
#    oled.text(str(bme280hum)     , 95, 27)
    oled.text("DS18B20         " ,  0, 36)
    oled.text(str(ds18b20takt[1]),  0, 45)
    oled.text(str(ds18b20takt[2]), 50, 45)
    oled.text(str(ds18b20takt[3]), 95, 45)
    oled.text(str(ds18b20takt[4]),  0, 54)
    oled.text(str(ds18b20takt[5]), 50, 54)
    oled.text(str(ds18b20takt[6]), 95, 54)
    oled.show()                                         # anzeigen
