from machine import Pin, I2C
import time

from config import Config
import onewire
import sensors.ds18x20
#import sensors.ssd1306

_config = Config()

if _config.get_value('sensors', 'ds1820', 'enabled'):
    ow = onewire.OneWire(
        Pin(_config.get_value('sensors', 'ds1820', 'pin')))
    ds1820 = sensors.ds18x20.DS18X20(ow)
    time.sleep_ms(200)
    i = 0
    while (i < 3 and len(ds1820.roms) < 6):
        time.sleep_ms(100)
        ds1820.__init__(ow)
        time.sleep_ms(400)
        i += 1
    if not ds1820.roms:
        print("No DS1820 found. Is it connected properly?")
    else:
        print("Found {} DS1820.".format(len(ds1820.roms)))

else:
    ds1820 = None
